org.springframework.web.bind.annotation

## Annotation Type ModelAttribute

-     @Target(value={PARAMETER,METHOD})
       @Retention(value=RUNTIME)
       @Documented
      public @interface ModelAttribute

  Annotation that binds a method parameter or method return value to a named model attribute, exposed to a web view. Supported for controller classes with `@RequestMapping` methods.

  WARNING: Data binding can lead to security issues by exposing parts of the object graph that are not meant to be accessed or modified by external clients. Therefore the design and use of data binding should be considered carefully with regard to security. For more details, please refer to the dedicated sections on data binding for Spring Web MVC and Spring WebFlux in the reference manual.

  `@ModelAttribute` can be used to expose command objects to a web view, using specific attribute names, by annotating corresponding parameters of an `@RequestMapping` method.

  `@ModelAttribute` can also be used to expose reference data to a web view by annotating accessor methods in a controller class with `@RequestMapping` methods. Such accessor methods are allowed to have any arguments that `@RequestMapping` methods support, returning the model attribute value to expose.

  Note however that reference data and all other model content are not available to web views when request processing results in an `Exception` since the exception could be raised at any time making the content of the model unreliable. For this reason `@ExceptionHandler` methods do not provide access to a `Model` argument.

  Since:
    2.5
  Author:
    Juergen Hoeller, Rossen Stoyanchev
  See Also:
    `ControllerAdvice`

- - ### Optional Element Summary

    Optional Elements
    Modifier and Type | Optional Element and Description
    --- | ---
    `boolean` | `binding` Allows data binding to be disabled directly on an `@ModelAttribute` method parameter or on the attribute returned from an `@ModelAttribute` method, both of which would prevent data binding for that attribute.
    `String` | `name` The name of the model attribute to bind to.
    `String` | `value` Alias for `name()`.

- - ### Element Detail

    - #### value

          @AliasFor(value="name")
          public abstract String value

      Alias for `name()`.
      Default:
        ""

  - - #### name

          @AliasFor(value="value")
          public abstract String name

      The name of the model attribute to bind to.

      The default model attribute name is inferred from the declared attribute type (i.e. the method parameter type or method return type), based on the non-qualified class name: e.g. "orderAddress" for class "mypackage.OrderAddress", or "orderAddressList" for "List<mypackage.OrderAddress>".

      Since:
        4.3
      Default:
        ""

  - - #### binding

          public abstract boolean binding

      Allows data binding to be disabled directly on an `@ModelAttribute` method parameter or on the attribute returned from an `@ModelAttribute` method, both of which would prevent data binding for that attribute.

      By default this is set to `true` in which case data binding applies. Set this to `false` to disable data binding.

      Since:
        4.3
      Default:
        true